Type: Package
Package: altdoc
Title: Package Documentation Websites with 'Quarto', 'Docsify',
        'Docute', or 'MkDocs'
Version: 0.4.0
Authors@R: 
    c(person(given = "Etienne",
             family = "Bacher",
             role = c("aut", "cre", "cph"),
             email = "etienne.bacher@protonmail.com"),
      person(given = "Vincent",
             family = "Arel-Bundock",
             role = "aut",
             email = "vincent.arel-bundock@umontreal.ca",
             comment = c(ORCID = "0000-0003-2042-7063"))
    )
Description: This is a simple and powerful package to create, render, preview, 
    and deploy documentation websites for 'R' packages. It is a lightweight and 
    flexible alternative to 'pkgdown', with support for many documentation 
    generators, including 'Quarto', 'Docute', 'Docsify', and 'MkDocs'.
License: MIT + file LICENSE
URL: https://altdoc.etiennebacher.com,
        https://github.com/etiennebacher/altdoc
BugReports: https://github.com/etiennebacher/altdoc/issues
Imports: cli, desc, evaluate, fs, quarto, tools, utils
Suggests: covr, digest, downlit, future, future.apply, knitr, servr,
        spelling, testthat (>= 3.0.0), usethis, withr, yaml
Config/testthat/edition: 3
Encoding: UTF-8
LazyData: true
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
Language: en-US
VignetteBuilder: knitr
Author: Etienne Bacher [aut, cre, cph],
  Vincent Arel-Bundock [aut] (<https://orcid.org/0000-0003-2042-7063>)
Maintainer: Etienne Bacher <etienne.bacher@protonmail.com>
Built: R 4.4.1; ; 2024-07-26 14:44:30 UTC; unix

Package: testpkg.altdoc
Type: Package
Title: What the Package Does (Title Case)
Version: 0.1.0
Author: Who wrote it
Maintainer: The package maintainer <yourself@somewhere.net>
Description: More about what it does (maybe more than one line)
    Use four spaces when indenting paragraphs within the Description.
License: What license is it under?
Encoding: UTF-8
LazyData: true
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.1
Imports: 
    R6
URL: https://github.com/etiennebacher/altdoc

<!-- README.md is generated from README.Rmd. Please edit that file -->

# testpkg.altdoc

<!-- badges: start -->

[![R-universe status
badge](https://grantmcdermott.r-universe.dev/badges/plot2)](https://grantmcdermott.r-universe.dev)
<!-- badges: end -->

The goal of testpkg.altdoc is to …

## Installation

You can install the development version of testpkg.altdoc like so:

``` r
# FILL THIS IN! HOW CAN PEOPLE INSTALL YOUR DEV PACKAGE?
```

## Example

This is a basic example which shows you how to solve a common problem:

``` r
library(testpkg.altdoc)
summary(cars)
#>      speed           dist       
#>  Min.   : 4.0   Min.   :  2.00  
#>  1st Qu.:12.0   1st Qu.: 26.00  
#>  Median :15.0   Median : 36.00  
#>  Mean   :15.4   Mean   : 42.98  
#>  3rd Qu.:19.0   3rd Qu.: 56.00  
#>  Max.   :25.0   Max.   :120.00
```

---
output: github_document
default-image-extension: ""
---

<!-- README.md is generated from README.Rmd. Please edit that file -->

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  fig.path = "man/figures/README-",
  out.width = "100%"
)
```

# testpkg.altdoc

<!-- badges: start -->
[![R-universe status badge](https://grantmcdermott.r-universe.dev/badges/plot2)](https://grantmcdermott.r-universe.dev)
<!-- badges: end -->

The goal of testpkg.altdoc is to ...

## Installation

You can install the development version of testpkg.altdoc like so:

``` r
# FILL THIS IN! HOW CAN PEOPLE INSTALL YOUR DEV PACKAGE?
```

## Example

This is a basic example which shows you how to solve a common problem:

```{r example}
library(testpkg.altdoc)
summary(cars)
```

#' Base function
#'
#' @param x A parameter
#'
#' @details
#' Some code with weird symbols: `pl$when(condition)` and `pl$then(output)`
#'
#' Some equations: \eqn{\partial Y / \partial X = a + \varepsilon/2}
#'
#'
#' @return Some value
#' @export
#'
#' @seealso \code{\link[base]{print}}, \code{\link{hello_r6}}
#'
#' @references Ihaka R, Gentleman R (1996).
#'   R: A Language for Data Analysis and Graphics.
#'   \emph{Journal of Computational and Graphical Statistics}. \bold{5}(3), 299--314.
#'   \doi{10.2307/139080}
#'
#' @examples
#' hello_base()
#'
#' mtcars$drat <- mtcars$drat + 1
#' head(mtcars[["drat"]], 2)
hello_base <- function(x = 2) {
  print("Hello, world!")
}

#' Create a "conductor" tour
#'
#' blah blah blah
#' @importFrom R6 R6Class
#' @export
hello_r6 <- R6::R6Class(
  "Conductor",
  private = list(x = 1),

  public = list(

    #' @details
    #' Initialise `Conductor`.
    initialize = function() {},

    #' @param session A valid Shiny session. If `NULL` (default), the function
    #' attempts to get the session with `shiny::getDefaultReactiveDomain()`.
    #'
    #' @details
    #' Initialise `Conductor`.
    init = function(session = NULL) {},

    #' @param title Title of the popover.
    #'
    #' @details
    #' Add a step in a `Conductor` tour.

    step = function(title = NULL) {}
  )
)

test_that(".rd2qmd works", {
  # .rd2qmd works only in pkg directory
  rd_file <- fs::path_abs(testthat::test_path("examples/examples-man/between.Rd"))
  create_local_package()
  fs::file_copy(rd_file, ".")
  fs::dir_create("docs")
  .rd2qmd(rd_file, "docs", path = ".")
  qmd_file <- fs::path_join(c("docs", "between.qmd"))
  expect_true(fs::file_exists(qmd_file))

  content <- .readlines(qmd_file)
  h3 <- grep("^### ", content, value = TRUE)
  expect_equal(
    h3,
    c("### Description", "### Usage", "### Arguments")
  )

  h2 <- grep("^## ", content, value = TRUE)
  expect_equal(h2, "## Do values in a numeric vector fall in specified range? {.unnumbered}")
})

test_that(".rd2qmd: basic errors", {
  expect_error(
    .rd2qmd("foo"),
    "must be a valid file path"
  )
  expect_error(
    .rd2qmd(testthat::test_path("examples/examples-man/between.Rd"), "foo", path = "."),
    "must be a valid directory"
  )
})

test_that("docute: main files are correct", {
  skip_on_cran()
  skip_if(.is_windows() && .on_ci(), "Windows on CI")

  ### setup: create a temp package using the structure of testpkg.altdoc
  path_to_example_pkg <- fs::path_abs(test_path("examples/testpkg.altdoc"))
  create_local_project()
  fs::dir_delete("R")
  fs::dir_copy(path_to_example_pkg, ".")
  all_files <- list.files("testpkg.altdoc", full.names = TRUE)
  for (i in all_files) {
    fs::file_move(i, ".")
  }
  fs::dir_delete("testpkg.altdoc")

  ### generate docs
  install.packages(".", repos = NULL, type = "source")
  setup_docs("docute")
  render_docs(verbose = .on_ci())

  ### test
  expect_snapshot(.readlines("docs/README.md"), variant = "docute")
  expect_snapshot(.readlines("docs/docute.html"), variant = "docute")
  expect_snapshot(.readlines("docs/NEWS.md"), variant = "docute")
  expect_snapshot(.readlines("docs/man/hello_base.md"), variant = "docute")
  expect_snapshot(.readlines("docs/man/hello_r6.md"), variant = "docute")
  expect_snapshot(.readlines("docs/man/examplesIf_true.md"), variant = "docute")
  expect_snapshot(.readlines("docs/man/examplesIf_false.md"), variant = "docute")
  expect_snapshot(.readlines("docs/vignettes/test.md"), variant = "docute")
})



test_that("docsify: main files are correct", {
  skip_on_cran()
  skip_if(.is_windows() && .on_ci(), "Windows on CI")

  ### setup: create a temp package using the structure of testpkg.altdoc
  path_to_example_pkg <- fs::path_abs(test_path("examples/testpkg.altdoc"))
  create_local_project()
  fs::dir_delete("R")
  fs::dir_copy(path_to_example_pkg, ".")
  all_files <- list.files("testpkg.altdoc", full.names = TRUE)
  for (i in all_files) {
    fs::file_move(i, ".")
  }
  fs::dir_delete("testpkg.altdoc")

  ### generate docs
  install.packages(".", repos = NULL, type = "source")
  setup_docs("docsify")
  render_docs(verbose = .on_ci())

  ### test
  expect_snapshot(.readlines("docs/README.md"), variant = "docsify")
  expect_snapshot(.readlines("docs/_sidebar.md"), variant = "docsify")
  expect_snapshot(.readlines("docs/index.html"), variant = "docsify")
  expect_snapshot(.readlines("docs/NEWS.md"), variant = "docsify")
  expect_snapshot(.readlines("docs/man/hello_base.md"), variant = "docsify")
  expect_snapshot(.readlines("docs/man/hello_r6.md"), variant = "docsify")
  expect_snapshot(.readlines("docs/man/examplesIf_true.md"), variant = "docsify")
  expect_snapshot(.readlines("docs/man/examplesIf_false.md"), variant = "docsify")
  expect_snapshot(.readlines("docs/vignettes/test.md"), variant = "docsify")
})



test_that("mkdocs: main files are correct", {
  skip_on_cran()
  skip_if_offline() # we download mkdocs every time
  skip_if(.is_windows() && .on_ci(), "Windows on CI")

  ### setup: create a temp package using the structure of testpkg.altdoc
  path_to_example_pkg <- fs::path_abs(test_path("examples/testpkg.altdoc"))
  create_local_project()
  fs::dir_delete("R")
  fs::dir_copy(path_to_example_pkg, ".")
  all_files <- list.files("testpkg.altdoc", full.names = TRUE)
  for (i in all_files) {
    fs::file_move(i, ".")
  }
  fs::dir_delete("testpkg.altdoc")

  ### special mkdocs stuff
  if (.is_windows()) {
    shell("python3 -m venv .venv_altdoc")
    shell(".venv_altdoc\\Scripts\\activate.bat && python3 -m pip install mkdocs --quiet")
  } else {
    system2("python3", "-m venv .venv_altdoc")
    system2("bash", "-c 'source .venv_altdoc/bin/activate && python3 -m pip install mkdocs --quiet'", stdout = FALSE)
  }

  ### generate docs
  install.packages(".", repos = NULL, type = "source")
  setup_docs("mkdocs")
  render_docs(verbose = .on_ci())

  ### test
  # no good way to test the site structure ("docs/mkdocs.yml" only shows
  # the old yaml, not the one with replaced variables)
  expect_snapshot(.readlines("docs/NEWS.md"), variant = "mkdocs")
  expect_snapshot(.readlines("docs/man/hello_base.md"), variant = "mkdocs")
  expect_snapshot(.readlines("docs/man/hello_r6.md"), variant = "mkdocs")
  expect_snapshot(.readlines("docs/vignettes/test.md"), variant = "mkdocs")
})



test_that("quarto: no error for basic workflow", {
  skip_on_cran()
  skip_if(.is_windows() && .on_ci(), "Windows on CI")

  ### setup: create a temp package using the structure of testpkg.altdoc
  path_to_example_pkg <- fs::path_abs(test_path("examples/testpkg.altdoc"))
  create_local_project()
  fs::dir_delete("R")
  fs::dir_copy(path_to_example_pkg, ".")
  all_files <- list.files("testpkg.altdoc", full.names = TRUE)
  for (i in all_files) {
    fs::file_move(i, ".")
  }
  fs::dir_delete("testpkg.altdoc")

  ### generate docs
  install.packages(".", repos = NULL, type = "source")
  fs::file_move("README.Rmd", "README.qmd") # special thing quarto
  setup_docs("quarto_website")
  expect_no_error(render_docs(verbose = .on_ci()))

  ### Quarto output changes depending on the version, I don't have a solution for
  ### now.

  ### test
  # expect_snapshot(.readlines("docs/index.html"))
  # expect_snapshot(.readlines("docs/NEWS.html"))
  # expect_snapshot(.readlines("docs/man/hello_base.html"))
  # expect_snapshot(.readlines("docs/man/hello_r6.html"))
  # expect_snapshot(.readlines("docs/vignettes/test.html"))
})


test_that("quarto: autolink", {
  skip_on_cran()
  skip_if(.is_windows() && .on_ci(), "Windows on CI")

  ### setup: create a temp package using the structure of testpkg.altdoc
  path_to_example_pkg <- fs::path_abs(test_path("examples/testpkg.altdoc"))
  create_local_project()
  fs::dir_delete("R")
  fs::dir_copy(path_to_example_pkg, ".")
  all_files <- list.files("testpkg.altdoc", full.names = TRUE)
  for (i in all_files) {
    fs::file_move(i, ".")
  }
  fs::dir_delete("testpkg.altdoc")

  ### generate docs
  install.packages(".", repos = NULL, type = "source")
  fs::file_move("README.Rmd", "README.qmd") # special thing quarto
  setup_docs("quarto_website")
  expect_no_error(render_docs(verbose = .on_ci()))

  tmp <- .readlines("docs/vignettes/test.html")
  expect_true(any(grepl("https://rdrr.io/r/base/library.html", tmp, fixed = TRUE)))
})


# Test failures ------------------------------

test_that("render_docs errors if vignettes fail", {
  create_local_package()
  fs::dir_create("vignettes")
  cat("# Get Started\n```{r}\n1 +\n```\n", file = "vignettes/foo.Rmd")
  setup_docs("docute", path = getwd())
  expect_error(
    render_docs(path = getwd()),
    "some failures when rendering vignettes"
  )
})

test_that("render_docs errors if man fail", {
  create_local_package()
  fs::dir_create("man")
  cat("\\name{hi}\n\\title{hi}\n\\usage{\nhi()\n}\n\\examples{\n1 +\n}\n", file = "man/foo.Rd")
  setup_docs("docute", path = getwd())
  expect_error(
    render_docs(path = getwd()),
    "some failures when rendering man pages"
  )
})

test_that("preview_docs: basic errors", {
  create_local_package()
  expect_error(
    preview_docs(),
    "No documentation tool detected"
  )

  setup_docs("docute")
  expect_error(
    preview_docs(),
    "You must render the docs before previewing them"
  )
})

test_that("must be a package", {
  create_local_project()
  expect_error(
    setup_docs(tool = "docute", path = getwd()),
    "only works in packages"
  )
})

test_that("setup_docs doesn't automatically overwrite", {
    create_local_package()
    setup_docs(tool = "docute", path = getwd())
    expect_error(
      setup_docs("docsify", path = getwd()),
      "already exists"
    )
})

test_that("setup_docs errors if missing tool", {
    create_local_package()
    expect_error(
      setup_docs(path = getwd()),
      "argument must be \"docsify\", \"docute\""
    )
})

test_that("overwrite=TRUE works: docute", {
    create_local_package()
    setup_docs(tool = "docute", path = getwd())
    cat("Cruft", file = "altdoc/docute.html", append = TRUE)
    txt <- readLines("altdoc/docute.html", warn = FALSE)
    expect_true("Cruft" %in% txt)
    setup_docs(tool = "docute", path = getwd(), overwrite = TRUE)
    txt <- readLines("altdoc/docute.html", warn = FALSE)
    expect_false("Cruft" %in% txt)
})

test_that("overwrite=TRUE works: docsify", {
    create_local_package()
    setup_docs(tool = "docsify", path = getwd())
    cat("Cruft", file = "altdoc/docsify.html", append = TRUE)
    txt <- readLines("altdoc/docsify.html", warn = FALSE)
    expect_true("Cruft" %in% txt)
    setup_docs(tool = "docsify", path = getwd(), overwrite = TRUE)
    txt <- readLines("altdoc/docsify.html", warn = FALSE)
    expect_false("Cruft" %in% txt)
})

test_that("overwrite=TRUE works: mkdocs", {
    skip_if_not(.venv_exists())
    create_local_package()
    setup_docs(tool = "mkdocs", path = getwd())
    cat("Cruft", file = "altdoc/mkdocs.yml", append = TRUE)
    txt <- readLines("altdoc/mkdocs.yml", warn = FALSE)
    expect_true("Cruft" %in% txt)
    setup_docs(tool = "mkdocs", path = getwd(), overwrite = TRUE)
    txt <- readLines("altdoc/mkdocs.yml", warn = FALSE)
    expect_false("Cruft" %in% txt)
})

test_that("quarto: README.qmd", {
  create_local_package()
  expect_false(file.exists("README.qmd"))
  setup_docs("quarto_website", overwrite = TRUE)
  expect_true(file.exists("README.qmd"))
})

test_that("comparing hashes works", {
  source_file <- tempfile()
  fs::file_copy(test_path("examples/examples-man/between.Rd"), source_file)
  hashes <- digest::digest(.readlines(source_file))
  names(hashes) <- source_file
  expect_true(.is_frozen(source_file, source_file, hashes))

  other_source_file <- test_path("examples/examples-man/between.md")
  expect_false(.is_frozen(other_source_file, other_source_file, hashes))

  # modified file doesn't have the same hash
  mod <- c(.readlines(source_file), "abc")
  cat(mod, file = source_file)
  expect_false(.is_frozen(source_file, source_file, hashes))
})

test_that(".is_frozen is FALSE if files don't exist", {
  source_file <- tempfile()
  fs::file_copy(test_path("examples/examples-man/between.Rd"), source_file)
  hashes <- digest::digest(.readlines(source_file))
  names(hashes) <- source_file
  expect_false(.is_frozen("foobar", "foobar", hashes))
})

test_that("rendering fails", {
  source <- test_path("examples/examples-man/should-fail.Rd")
  dest <- tempfile(fileext = ".Rd")
  fs::file_copy(source, dest)

  create_local_package()
  setup_docs("docute")
  fs::dir_create("man")
  fs::file_copy(dest, "man")
  src <- fs::path_ext_remove(list.files("man"))
  expect_equal(
    .render_one_man(src, tool = "docute", src_dir = ".", tar_dir = ".", freeze = FALSE, hashes = NULL),
    "failure"
  )
})

test_that("rendering skipped because internal", {
  source <- test_path("examples/examples-man/is-internal.Rd")
  dest <- tempfile(fileext = ".Rd")
  fs::file_copy(source, dest)

  create_local_package()
  setup_docs("docute")
  fs::dir_create("man")
  fs::file_copy(dest, "man")
  src <- fs::path_ext_remove(list.files("man"))
  expect_equal(
    .render_one_man(src, tool = "docute", src_dir = ".", tar_dir = ".", freeze = FALSE, hashes = NULL),
    "skipped_internal"
  )
})

test_that("rendering skipped because unchanged and freeze = TRUE", {
  # writing freeze.rds is disabled in CI
  skip_on_ci()
  source <- test_path("examples/examples-man/between.Rd")
  dest <- tempfile(fileext = ".Rd")
  fs::file_copy(source, dest)

  create_local_package()
  setup_docs("docute")
  fs::dir_create("man")
  fs::file_copy(dest, "man")
  src <- fs::path_ext_remove(list.files("man"))

  # first rendering to store the hash
  .render_one_man(src, tool = "docute", src_dir = ".", tar_dir = ".", freeze = FALSE, hashes = NULL)
  .update_freeze(".", src, successes = 1, fails = NULL, type = "man")
  hashes <- .get_hashes(".", freeze = TRUE)

  expect_equal(
    .render_one_man(src, tool = "docute", src_dir = ".", tar_dir = ".", freeze = TRUE, hashes = hashes),
    "skipped_unchanged"
  )
})

test_that(".folder_is_empty() works", {
  create_local_package()
  fs::dir_create("docs")
  expect_true(.folder_is_empty("docs"))

  fs::file_create("docs/test.md")
  expect_false(.folder_is_empty("docs"))
})

test_that(".pkg_name() works", {
  create_local_package()
  expect_true(is.character(.pkg_name(getwd())))
  expect_true(nchar(.pkg_name(getwd())) > 0)
})

test_that(".pkg_version() works", {
  create_local_package()
  expect_true(is.character(.pkg_version(".")))
  expect_true(nchar(.pkg_version(".")) > 0)
})

test_that(".parse_news works", {
  skip_if_not_installed("desc")
  create_local_package()
  desc::desc_set_urls("https://github.com/etiennebacher/altdoc")
  input <- "# 1.1.0\n\n* thanks @foo-bar for their contribution (#111)\n\n* thanks @foo2- for their contribution (#11)\n\n* due to issue in another repo (pola-rs/polars#112)\n\n* thanks @JohnDoe, @JaneDoe"
  cat(input, file = "NEWS.md")
  .parse_news(".", "NEWS.md")
  parsed <- paste(.readlines("NEWS.md"), collapse = "")

  should_be_found <- c(
    "[@foo-bar](https://github.com/foo-bar)",
    "[#111](https://github.com/etiennebacher/altdoc/issues/111)",
    "[@foo2-](https://github.com/foo2-)",
    "[#11](https://github.com/etiennebacher/altdoc/issues/11)",
    "[@JohnDoe](https://github.com/JohnDoe), [@JaneDoe](https://github.com/JaneDoe)"
  )

  expect_true(
    all(sapply(should_be_found, grepl, x = parsed, fixed = TRUE))
  )
})

test_that(".which_license works", {
  create_local_package()
  fs::file_create("LICENSE.md")
  expect_equal(.which_license(), "LICENSE.md")
  fs::file_delete("LICENSE.md")
  fs::file_create("LICENCE.md")
  expect_equal(.which_license(), "LICENCE.md")
  fs::file_delete("LICENCE.md")
  expect_null(.which_license())
})

test_that(".find_head_branch works if no git", {
  create_local_package()
  expect_null(.find_head_branch())
})

# README --------------------------------------------------------

for (tool in c("docute", "docsify")) {
  test_that(sprintf("render_docs updates correctly the README: %s", tool), {
    skip_if(tool == "mkdocs" && !.venv_exists())
    create_local_package()
    setup_docs(tool = tool, path = getwd())
    usethis::use_readme_md(open = FALSE)
    render_docs(path = getwd())
    readme1 <- .readlines("README.md")
    readme2 <- .readlines("docs/README.md")
    expect_true(identical(readme1, readme2))
  })
}




# NEWS --------------------------------------------------------

for (tool in c("docute", "docsify")) {
  test_that(sprintf("render_docs updates correctly the NEWS: %s", tool), {
    skip_if(tool == "mkdocs" && !.venv_exists())
    create_local_package()
    # https://github.com/cynkra/fledge/issues/683
    withr::with_options(
      list(repos = c("CRAN" = "https://cloud.r-project.org")),
      {
        usethis::use_news_md()
    })
    setup_docs(tool = tool, path = getwd(), overwrite = TRUE)
    writeLines("Hello", con = "NEWS.md")
    render_docs(path = getwd())
    writeLines("Hello again", con = "NEWS.md")
    news1 <- .readlines("NEWS.md")
    news2 <- .readlines("docs/NEWS.md")
    expect_false(identical(news1, news2))
    render_docs(path = getwd())
    news2 <- .readlines("docs/NEWS.md")
    expect_true(identical(news1, news2))
  })
}




# CODE OF CONDUCT --------------------------------------------------------

for (tool in c("docute", "docsify")) {
  test_that(sprintf("docute: render_docs updates correctly the CoC, %s", tool), {
    skip_if(tool == "mkdocs" && !.venv_exists())
    create_local_package()
    usethis::use_code_of_conduct("etienne.bacher@protonmail.com")
    writeLines("Hello", con = "CODE_OF_CONDUCT.md")
    setup_docs(tool = tool, path = getwd())
    render_docs(path = getwd())
    writeLines("Hello again", con = "CODE_OF_CONDUCT.md")
    news1 <- .readlines("CODE_OF_CONDUCT.md")
    news2 <- .readlines("docs/CODE_OF_CONDUCT.md")
    expect_false(identical(news1, news2))
    render_docs(path = getwd())
    news2 <- .readlines("docs/CODE_OF_CONDUCT.md")
    expect_true(identical(news1, news2))
  })
}




# LICENSE --------------------------------------------------------

for (tool in c("docute", "docsify")) {
  test_that(sprintf("render_docs updates correctly the License: %s", tool), {
    skip_if(tool == "mkdocs" && !.venv_exists())
    create_local_package()
    usethis::use_mit_license("etienne.bacher@protonmail.com")
    writeLines("Hello", con = "LICENSE.md")
    setup_docs(tool = tool, path = getwd())
    render_docs(path = getwd())
    writeLines("Hello again", con = "LICENSE.md")
    news1 <- .readlines("LICENSE.md")
    news2 <- .readlines("docs/LICENSE.md")
    expect_false(identical(news1, news2))
    render_docs(path = getwd())
    news2 <- .readlines("docs/LICENSE.md")
    expect_true(identical(news1, news2))
  })
}





# VIGNETTES --------------------------------------------------------

for (tool in c("docute", "docsify")) {
  test_that(sprintf("render_docs also transform new/modified vignettes if specified: %s", tool), {
    skip_on_ci()
    skip_if(tool == "mkdocs" && !.venv_exists())
    # setup
    first_rmd <- .readlines(
      testthat::test_path("examples/examples-vignettes", "basic.Rmd")
    )
    second_rmd <- .readlines(
      testthat::test_path("examples/examples-vignettes", "several-outputs.Rmd")
    )
    create_local_package()
    fs::dir_create("vignettes")
    writeLines(first_rmd, "vignettes/basic.Rmd")
    setup_docs(tool = tool, path = getwd())
    render_docs(path = getwd())
    writeLines(second_rmd, "vignettes/several-outputs.Rmd")
    expect_false(fs::file_exists("docs/vignettes/several-outputs.md"))
    # mkdocs does not accept duplicate vignette names
    if (tool != "mkdocs") {
      render_docs(path = getwd())
      expect_true(fs::file_exists("docs/vignettes/several-outputs.md"))
    }
  })
}

test_that(".reformat_md works", {
  # Need to write and read to avoid all \n differences
  create_local_package()
  setup_docs(tool = "docsify", path = getwd())
  tmp <- fs::file_temp(ext = ".md")
  txt <- "# Package

# Installation

Well hello there

## Stable version

Here's some code:

```r
# here's a comment
1 + 1
```

## Dev version

Hello

# Demo

Hello again
"
  cat(txt, file = "README.md")
  expect_message(render_docs(), "assumes that the only level 1")
})

test_that(".substitute_altdoc_vars removes github if no url", {
  create_local_package()
  desc::desc_set_urls("https://foobar.com")
  setup_docs("docute")
  render_docs()
  content <- .readlines("docs/index.html")
  expect_false(any(grepl("$ALTDOC_PACKAGE_URL_GITHUB", content, fixed = TRUE)))
})

test_that(".substitute_altdoc_vars removes website if no url", {
  create_local_package()
  desc::desc_set_urls("https://github.com/foo/bar")
  setup_docs("docute")
  render_docs()
  content <- .readlines("docs/index.html")
  expect_false(any(grepl("$ALTDOC_PACKAGE_URL", content, fixed = TRUE)))
})

library(fs)
library(usethis)
library(withr)

### Don't run mkdocs in other places than my laptop
### It requires installing pip3 and mkdocs, which is not possible on CRAN
### (to my knowledge)
skip_mkdocs <- function() {
  skip_on_cran()
  skip_if_not(.venv_exists())
}


### Taken from {usethis} (file "R/project.R")

proj <- new.env(parent = emptyenv())

proj_get_ <- function() proj$cur

proj_set_ <- function(path) {
  old <- proj$cur
  proj$cur <- path
  invisible(old)
}



### Taken from {usethis} (file "tests/testthat/helper.R")

create_local_package <- function(
    dir = fs::file_temp(pattern = "testpkg"),
    env = parent.frame(),
    rstudio = TRUE) {
  create_local_thing(dir, env, rstudio, "package")
}


create_local_project <- function(
    dir = fs::file_temp(pattern = "testproj"),
    env = parent.frame(),
    rstudio = FALSE) {
  create_local_thing(dir, env, rstudio, "project")
}


create_local_thing <- function(
    dir = fs::file_temp(pattern = pattern),
    env = parent.frame(),
    rstudio = FALSE,
    thing = c("package", "project")) {
  thing <- match.arg(thing)
  if (fs::dir_exists(dir)) {
    ui_stop("Target {ui_code('dir')} {.file {dir}} already exists.")
  }

  old_project <- proj_get_() # this could be `NULL`, i.e. no active project
  old_wd <- getwd() # not necessarily same as `old_project`

  withr::defer(
    {
      fs::dir_delete(dir)
    },
    envir = env
  )
  usethis::ui_silence(
    switch(thing,
      package = create_package(dir, rstudio = rstudio, open = FALSE, check_name = FALSE),
      project = create_project(dir, rstudio = rstudio, open = FALSE)
    )
  )

  defer(proj_set(old_project, force = TRUE), envir = env)
  proj_set(dir)

  defer(
    {
      setwd(old_wd)
    },
    envir = env
  )
  setwd(proj_get())

  invisible(proj_get())
}


expect_proj_file <- function(...) expect_true(fs::file_exists(proj_path(...)))

test_that(".setup_github_actions cannot overwrite", {
  create_local_package()
  setup_docs("docute")
  fs::dir_create(".github/workflows")
  fs::file_create(".github/workflows/altdoc.yaml")
  expect_error(
    setup_github_actions(),
    "already exists"
  )
})

test_that(".setup_github_actions works if not mkdocs", {
  create_local_package()
  setup_docs("docute")
  setup_github_actions()
  expect_true(fs::file_exists(".github/workflows/altdoc.yaml"))
  content <- .readlines(".github/workflows/altdoc.yaml")
  expect_false(any(grepl("$ALTDOC_MKDOCS_START", content, fixed = TRUE)))
  expect_false(any(grepl("install mkdocs", content, fixed = TRUE)))
})

test_that(".setup_github_actions works if mkdocs", {
  skip_if_not(.venv_exists())
  create_local_package()
  setup_docs("mkdocs")
  setup_github_actions()
  expect_true(fs::file_exists(".github/workflows/altdoc.yaml"))
  content <- .readlines(".github/workflows/altdoc.yaml")
  expect_false(any(grepl("$ALTDOC_MKDOCS_START", content, fixed = TRUE)))
  expect_true(any(grepl("install mkdocs", content, fixed = TRUE)))
})

test_that("use template preamble if no preamble in file", {
  source <- tempfile(fileext = ".qmd")
  fs::file_copy(test_path("examples/examples-qmd/without-preamble.qmd"), source)
  create_local_package()
  setup_docs("docute")
  fs::dir_create("vignettes")
  fs::file_copy(source, "vignettes")
  preamble <- .readlines("altdoc/preamble_vignettes_qmd.yml")
  vignette_qmd <- list.files("vignettes", full.names = TRUE)[1]

  .qmd2md(vignette_qmd, "vignettes", preamble = preamble)
  vignette_md <- list.files("vignettes", full.names = TRUE, pattern = "\\.md$")[1]

  # we use our preamble so quarto shouldn't automatically add the ".png" extension
  content <- .readlines(vignette_md)
  expect_true(any(grepl("badges/plot2)", content, fixed = TRUE)))
})

test_that("do not use template preamble if preamble in file", {
  source <- tempfile(fileext = ".qmd")
  fs::file_copy(test_path("examples/examples-qmd/with-preamble.qmd"), source)
  create_local_package()
  setup_docs("docute")
  fs::dir_create("vignettes")
  fs::file_copy(source, "vignettes")
  preamble <- .readlines("altdoc/preamble_vignettes_qmd.yml")
  vignette_qmd <- list.files("vignettes", full.names = TRUE)[1]
  .qmd2md(vignette_qmd, "vignettes", preamble = preamble)

  vignette_md <- list.files("vignettes", full.names = TRUE, pattern = "\\.md$")[1]

  # there's already a preamble so we don't use ours. Quarto should automatically
  # add the ".png" extension
  content <- .readlines(vignette_md)
  expect_true(any(grepl("badges/plot2.png)", content, fixed = TRUE)))
})

for (tool in c("docute", "docsify", "mkdocs")) {
  test_that(sprintf("render_docs works in parallel: %s", tool), {
    skip_if(tool == "mkdocs" && !.venv_exists())
    create_local_package()
    setup_docs(tool = tool, path = getwd())
    usethis::use_readme_md(open = FALSE)
    expect_no_error(render_docs(path = getwd(), parallel = TRUE))
  })
}

* [Home](/)
* Articles: $ALTDOC_VIGNETTE_BLOCK
* Reference: $ALTDOC_MAN_BLOCK
* [News]($ALTDOC_NEWS)
* [Changelog]($ALTDOC_CHANGELOG)
* [Code of Conduct]($ALTDOC_CODE_OF_CONDUCT)
* [License]($ALTDOC_LICENSE)
* [Licence]($ALTDOC_LICENCE)
* [Citation]($ALTDOC_CITATION)

---
title: "Analysing Longitudinal or Panel Data"
output: 
  rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Analysing Longitudinal or Panel Data}
  \usepackage[utf8]{inputenc}
  %\VignetteEngine{knitr::rmarkdown}
---

Hello this is a vignette.

Here's some code:

```{r}
print(mtcars)

plot(mtcars$mpg)
```

Here's a figure: ![](hex-conductor.png)

Here's a link to a figure: <img src="https://raw.githubusercontent.com/etiennebacher/altdoc/main/inst/misc/hex-conductor.png">

Here's another figure: ![](figures/hex-conductor-2.png)

### Description

This is a shortcut for `x >= left & x <= right`, implemented efficiently
in C++ for local values, and translated to the appropriate SQL for
remote tables.

### Usage

      between(x, left, right)

### Arguments

<table>
<tbody>
<tr class="odd" data-valign="top">
<td><code>x</code></td>
<td><p>A numeric vector of values</p></td>
</tr>
<tr class="even" data-valign="top">
<td><code>left, right</code></td>
<td><p>Boundary values (must be scalars).</p></td>
</tr>
</tbody>
</table>

### Examples

```r
  between(1:12, 7, 9)

  x <- rnorm(1e2)
  x[between(x, -1, 1)]

  ## Or on a tibble using filter
  filter(starwars, between(height, 100, 150))
```


---

---
title: "Analysing Longitudinal or Panel Data"
author: Etienne Bacher
date: 01-01-1970
output: 
  rmarkdown::html_vignette: default
  rmarkdown::pdf_document:
    engine: xelatex
vignette: >
  %\VignetteIndexEntry{Analysing Longitudinal or Panel Data}
  \usepackage[utf8]{inputenc}
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
---

Hello this is a vignette.

Here's some code:

```{r}
print(mtcars)
```

# docsify: main files are correct

    Code
      .readlines("docs/README.md")
    Output
       [1] ""                                                                                                  
       [2] ""                                                                                                  
       [3] "<!-- README.md is generated from README.Rmd. Please edit that file -->"                            
       [4] ""                                                                                                  
       [5] "# testpkg.altdoc"                                                                                  
       [6] ""                                                                                                  
       [7] "<!-- badges: start -->"                                                                            
       [8] ""                                                                                                  
       [9] "[![R-universe status"                                                                              
      [10] "badge](https://grantmcdermott.r-universe.dev/badges/plot2)](https://grantmcdermott.r-universe.dev)"
      [11] "<!-- badges: end -->"                                                                              
      [12] ""                                                                                                  
      [13] "The goal of testpkg.altdoc is to …"                                                                
      [14] ""                                                                                                  
      [15] "## Installation"                                                                                   
      [16] ""                                                                                                  
      [17] "You can install the development version of testpkg.altdoc like so:"                                
      [18] ""                                                                                                  
      [19] "``` r"                                                                                             
      [20] "# FILL THIS IN! HOW CAN PEOPLE INSTALL YOUR DEV PACKAGE?"                                          
      [21] "```"                                                                                               
      [22] ""                                                                                                  
      [23] "## Example"                                                                                        
      [24] ""                                                                                                  
      [25] "This is a basic example which shows you how to solve a common problem:"                            
      [26] ""                                                                                                  
      [27] "``` r"                                                                                             
      [28] "library(testpkg.altdoc)"                                                                           
      [29] "summary(cars)"                                                                                     
      [30] "#>      speed           dist       "                                                               
      [31] "#>  Min.   : 4.0   Min.   :  2.00  "                                                               
      [32] "#>  1st Qu.:12.0   1st Qu.: 26.00  "                                                               
      [33] "#>  Median :15.0   Median : 36.00  "                                                               
      [34] "#>  Mean   :15.4   Mean   : 42.98  "                                                               
      [35] "#>  3rd Qu.:19.0   3rd Qu.: 56.00  "                                                               
      [36] "#>  Max.   :25.0   Max.   :120.00"                                                                 
      [37] "```"                                                                                               

---

    Code
      .readlines("docs/_sidebar.md")
    Output
       [1] "* [Home](/)"                                 
       [2] "* Articles: "                                
       [3] "  - [here.pdf](vignettes/here.pdf ':ignore')"
       [4] "  - [test](vignettes/test.md)"               
       [5] "* Reference: "                               
       [6] "  - [examplesIf_false](man/examplesIf_false)"
       [7] "  - [examplesIf_true](man/examplesIf_true)"  
       [8] "  - [hello_base](man/hello_base)"            
       [9] "  - [hello_r6](man/hello_r6)"                
      [10] "* [News](NEWS.md)"                           
      [11] "* [Citation](CITATION.md)"                   

---

    Code
      .readlines("docs/index.html")
    Output
       [1] "<!-- index.html -->"                                                                    
       [2] ""                                                                                       
       [3] "<!DOCTYPE html>"                                                                        
       [4] "<html>"                                                                                 
       [5] "<head>"                                                                                 
       [6] "  <meta http-equiv=\"X-UA-Compatible\" content=\"IE=edge,chrome=1\">"                   
       [7] "  <meta name=\"viewport\" content=\"width=device-width,initial-scale=1\">"              
       [8] "  <meta charset=\"UTF-8\">"                                                             
       [9] "  <link rel=\"stylesheet\" href=\"//cdn.jsdelivr.net/npm/docsify@4/themes/vue.css\" />" 
      [10] "</head>"                                                                                
      [11] "<body>"                                                                                 
      [12] "  <div id=\"app\"></div>"                                                               
      [13] "  <script>"                                                                             
      [14] "    window.$docsify = {"                                                                
      [15] "      name: 'testpkg.altdoc',"                                                          
      [16] "      repo: 'https://github.com/etiennebacher/altdoc',"                                 
      [17] "      loadSidebar: true,"                                                               
      [18] "      subMaxLevel: 2,"                                                                  
      [19] "      search: {"                                                                        
      [20] "        placeholder: 'Search',"                                                         
      [21] "        depth: 3,"                                                                      
      [22] "      },"                                                                               
      [23] "      auto2top: true,"                                                                  
      [24] "      copyCode: {"                                                                      
      [25] "        buttonText : 'Copy',"                                                           
      [26] "        errorText  : 'Error',"                                                          
      [27] "        successText: 'Copied'"                                                          
      [28] "      },"                                                                               
      [29] "      plugins: ["                                                                       
      [30] "        function(hook) {"                                                               
      [31] ""                                                                                       
      [32] "          hook.afterEach(function(html) {"                                              
      [33] "            return html + footer;"                                                      
      [34] "          });"                                                                          
      [35] "        }"                                                                              
      [36] "      ]"                                                                                
      [37] "    }"                                                                                  
      [38] "  </script>"                                                                            
      [39] "  <script src=\"//cdn.jsdelivr.net/npm/docsify@4\"></script>"                           
      [40] "  <script src=\"//cdn.jsdelivr.net/npm/docsify-copy-code\"></script>"                   
      [41] "  <script src=\"//cdn.jsdelivr.net/npm/prismjs@1.24.1/components/prism-r.js\"></script>"
      [42] "  <script src=\"//unpkg.com/docsify/lib/plugins/search.min.js\"></script>"              
      [43] "</body>"                                                                                
      [44] "</html>"                                                                                

---

    Code
      .readlines("docs/NEWS.md")
    Output
      [1] "# foobar 1.1.0"                                                                                                                     
      [2] ""                                                                                                                                   
      [3] "* thanks [@foo-bar](https://github.com/foo-bar) for their contribution ([#111](https://github.com/etiennebacher/altdoc/issues/111))"
      [4] ""                                                                                                                                   
      [5] "* thanks [@foo2-](https://github.com/foo2-) for their contribution ([#11](https://github.com/etiennebacher/altdoc/issues/11))"      
      [6] ""                                                                                                                                   
      [7] "* thanks [@JohnDoe](https://github.com/JohnDoe), [@JaneDoe](https://github.com/JaneDoe)"                                            
      [8] ""                                                                                                                                   
      [9] "* this should not be linked: foo.bar@email.com"                                                                                     

---

    Code
      .readlines("docs/man/hello_base.md")
    Output
       [1] ""                                                                               
       [2] ""                                                                               
       [3] "# Base function"                                                                
       [4] ""                                                                               
       [5] "## Description"                                                                 
       [6] ""                                                                               
       [7] "Base function"                                                                  
       [8] ""                                                                               
       [9] "## Usage"                                                                       
      [10] ""                                                                               
      [11] "<pre><code class='language-R'>hello_base(x = 2)"                                
      [12] "</code></pre>"                                                                  
      [13] ""                                                                               
      [14] "## Arguments"                                                                   
      [15] ""                                                                               
      [16] "<table>"                                                                        
      [17] "<tr>"                                                                           
      [18] "<td style=\"white-space: nowrap; font-family: monospace; vertical-align: top\">"
      [19] "<code id=\"x\">x</code>"                                                        
      [20] "</td>"                                                                          
      [21] "<td>"                                                                           
      [22] "A parameter"                                                                    
      [23] "</td>"                                                                          
      [24] "</tr>"                                                                          
      [25] "</table>"                                                                       
      [26] ""                                                                               
      [27] "## Details"                                                                     
      [28] ""                                                                               
      [29] "Some code with weird symbols: <code>pl$when(condition)</code> and"              
      [30] "<code>pl$then(output)</code>"                                                   
      [31] ""                                                                               
      [32] "Some equations: ∂*Y*/∂*X* = *a* + *ε*/2"                                        
      [33] ""                                                                               
      [34] "## Value"                                                                       
      [35] ""                                                                               
      [36] "Some value"                                                                     
      [37] ""                                                                               
      [38] "## References"                                                                  
      [39] ""                                                                               
      [40] "Ihaka R, Gentleman R (1996). R: A Language for Data Analysis and"               
      [41] "Graphics. <em>Journal of Computational and Graphical Statistics</em>."          
      [42] "<b>5</b>(3), 299–314."                                                          
      [43] "[doi:10.2307/139080](https://doi.org/10.2307/139080)"                           
      [44] ""                                                                               
      [45] "## See Also"                                                                    
      [46] ""                                                                               
      [47] "<code>print</code>, <code>hello_r6</code>"                                      
      [48] ""                                                                               
      [49] "## Examples"                                                                    
      [50] ""                                                                               
      [51] "``` r"                                                                          
      [52] "library(\"testpkg.altdoc\")"                                                    
      [53] ""                                                                               
      [54] "hello_base()"                                                                   
      [55] "```"                                                                            
      [56] ""                                                                               
      [57] "    [1] \"Hello, world!\""                                                      
      [58] ""                                                                               
      [59] "``` r"                                                                          
      [60] "mtcars$drat <- mtcars$drat + 1"                                                 
      [61] "head(mtcars[[\"drat\"]], 2)"                                                    
      [62] "```"                                                                            
      [63] ""                                                                               
      [64] "    [1] 4.9 4.9"                                                                

---

    Code
      .readlines("docs/man/hello_r6.md")
    Output
        [1] ""                                                                     
        [2] ""                                                                     
        [3] "# Create a \"conductor\" tour"                                        
        [4] ""                                                                     
        [5] "## Description"                                                       
        [6] ""                                                                     
        [7] "blah blah blah"                                                       
        [8] ""                                                                     
        [9] "## Methods"                                                           
       [10] ""                                                                     
       [11] "<h4>"                                                                 
       [12] "Public methods"                                                       
       [13] "</h4>"                                                                
       [14] "<ul>"                                                                 
       [15] "<li>"                                                                 
       [16] ""                                                                     
       [17] "<a href=\"#method-Conductor-new\"><code>hello_r6$new()</code></a>"    
       [18] ""                                                                     
       [19] "</li>"                                                                
       [20] "<li>"                                                                 
       [21] ""                                                                     
       [22] "<a href=\"#method-Conductor-init\"><code>hello_r6$init()</code></a>"  
       [23] ""                                                                     
       [24] "</li>"                                                                
       [25] "<li>"                                                                 
       [26] ""                                                                     
       [27] "<a href=\"#method-Conductor-step\"><code>hello_r6$step()</code></a>"  
       [28] ""                                                                     
       [29] "</li>"                                                                
       [30] "<li>"                                                                 
       [31] ""                                                                     
       [32] "<a href=\"#method-Conductor-clone\"><code>hello_r6$clone()</code></a>"
       [33] ""                                                                     
       [34] "</li>"                                                                
       [35] "</ul>"                                                                
       [36] "<hr>"                                                                 
       [37] ""                                                                     
       [38] "<a id=\"method-Conductor-new\"></a>"                                  
       [39] ""                                                                     
       [40] "<h4>"                                                                 
       [41] "Method <code>new()</code>"                                            
       [42] "</h4>"                                                                
       [43] "<h5>"                                                                 
       [44] "Usage"                                                                
       [45] "</h5>"                                                                
       [46] ""                                                                     
       [47] "<pre>hello_r6\\$new()</pre>"                                          
       [48] ""                                                                     
       [49] "<h5>"                                                                 
       [50] "Details"                                                              
       [51] "</h5>"                                                                
       [52] ""                                                                     
       [53] "Initialise <code>Conductor</code>."                                   
       [54] ""                                                                     
       [55] "<hr>"                                                                 
       [56] ""                                                                     
       [57] "<a id=\"method-Conductor-init\"></a>"                                 
       [58] ""                                                                     
       [59] "<h4>"                                                                 
       [60] "Method <code>init()</code>"                                           
       [61] "</h4>"                                                                
       [62] "<h5>"                                                                 
       [63] "Usage"                                                                
       [64] "</h5>"                                                                
       [65] ""                                                                     
       [66] "<pre>hello_r6\\$init(session = NULL)</pre>"                           
       [67] ""                                                                     
       [68] "<h5>"                                                                 
       [69] "Arguments"                                                            
       [70] "</h5>"                                                                
       [71] ""                                                                     
       [72] "<dl>"                                                                 
       [73] "<dt>"                                                                 
       [74] "<code>session</code>"                                                 
       [75] "</dt>"                                                                
       [76] "<dd>"                                                                 
       [77] "A valid Shiny session. If <code>NULL</code> (default), the function"  
       [78] "attempts to get the session with"                                     
       [79] "<code>shiny::getDefaultReactiveDomain()</code>."                      
       [80] "</dd>"                                                                
       [81] "</dl>"                                                                
       [82] ""                                                                     
       [83] "<h5>"                                                                 
       [84] "Details"                                                              
       [85] "</h5>"                                                                
       [86] ""                                                                     
       [87] "Initialise <code>Conductor</code>."                                   
       [88] ""                                                                     
       [89] "<hr>"                                                                 
       [90] ""                                                                     
       [91] "<a id=\"method-Conductor-step\"></a>"                                 
       [92] ""                                                                     
       [93] "<h4>"                                                                 
       [94] "Method <code>step()</code>"                                           
       [95] "</h4>"                                                                
       [96] "<h5>"                                                                 
       [97] "Usage"                                                                
       [98] "</h5>"                                                                
       [99] ""                                                                     
      [100] "<pre>hello_r6\\$step(title = NULL)</pre>"                             
      [101] ""                                                                     
      [102] "<h5>"                                                                 
      [103] "Arguments"                                                            
      [104] "</h5>"                                                                
      [105] ""                                                                     
      [106] "<dl>"                                                                 
      [107] "<dt>"                                                                 
      [108] "<code>title</code>"                                                   
      [109] "</dt>"                                                                
      [110] "<dd>"                                                                 
      [111] "Title of the popover."                                                
      [112] "</dd>"                                                                
      [113] "</dl>"                                                                
      [114] ""                                                                     
      [115] "<h5>"                                                                 
      [116] "Details"                                                              
      [117] "</h5>"                                                                
      [118] ""                                                                     
      [119] "Add a step in a <code>Conductor</code> tour."                         
      [120] ""                                                                     
      [121] "<hr>"                                                                 
      [122] ""                                                                     
      [123] "<a id=\"method-Conductor-clone\"></a>"                                
      [124] ""                                                                     
      [125] "<h4>"                                                                 
      [126] "Method <code>clone()</code>"                                          
      [127] "</h4>"                                                                
      [128] ""                                                                     
      [129] "The objects of this class are cloneable with this method."            
      [130] ""                                                                     
      [131] "<h5>"                                                                 
      [132] "Usage"                                                                
      [133] "</h5>"                                                                
      [134] ""                                                                     
      [135] "<pre>hello_r6\\$clone(deep = FALSE)</pre>"                            
      [136] ""                                                                     
      [137] "<h5>"                                                                 
      [138] "Arguments"                                                            
      [139] "</h5>"                                                                
      [140] ""                                                                     
      [141] "<dl>"                                                                 
      [142] "<dt>"                                                                 
      [143] "<code>deep</code>"                                                    
      [144] "</dt>"                                                                
      [145] "<dd>"                                                                 
      [146] "Whether to make a deep clone."                                        
      [147] "</dd>"                                                                
      [148] "</dl>"                                                                

---

    Code
      .readlines("docs/man/examplesIf_true.md")
    Output
       [1] ""                                                                               
       [2] ""                                                                               
       [3] "# Examples If TRUE"                                                             
       [4] ""                                                                               
       [5] "## Description"                                                                 
       [6] ""                                                                               
       [7] "Examples If TRUE"                                                               
       [8] ""                                                                               
       [9] "## Usage"                                                                       
      [10] ""                                                                               
      [11] "<pre><code class='language-R'>examplesIf_true()"                                
      [12] "</code></pre>"                                                                  
      [13] ""                                                                               
      [14] "## Arguments"                                                                   
      [15] ""                                                                               
      [16] "<table>"                                                                        
      [17] "<tr>"                                                                           
      [18] "<td style=\"white-space: nowrap; font-family: monospace; vertical-align: top\">"
      [19] "<code id=\"x\">x</code>"                                                        
      [20] "</td>"                                                                          
      [21] "<td>"                                                                           
      [22] "A parameter"                                                                    
      [23] "</td>"                                                                          
      [24] "</tr>"                                                                          
      [25] "</table>"                                                                       
      [26] ""                                                                               
      [27] "## Value"                                                                       
      [28] ""                                                                               
      [29] "Some value"                                                                     
      [30] ""                                                                               
      [31] "## Examples"                                                                    
      [32] ""                                                                               
      [33] "``` r"                                                                          
      [34] "library(\"testpkg.altdoc\")"                                                    
      [35] ""                                                                               
      [36] ""                                                                               
      [37] "examplesIf_true()"                                                              
      [38] "```"                                                                            
      [39] ""                                                                               
      [40] "    [1] \"Hello, world!\""                                                      

---

    Code
      .readlines("docs/man/examplesIf_false.md")
    Output
       [1] ""                                                                               
       [2] ""                                                                               
       [3] "# Examples If FALSE"                                                            
       [4] ""                                                                               
       [5] "## Description"                                                                 
       [6] ""                                                                               
       [7] "Examples If FALSE"                                                              
       [8] ""                                                                               
       [9] "## Usage"                                                                       
      [10] ""                                                                               
      [11] "<pre><code class='language-R'>examplesIf_false()"                               
      [12] "</code></pre>"                                                                  
      [13] ""                                                                               
      [14] "## Arguments"                                                                   
      [15] ""                                                                               
      [16] "<table>"                                                                        
      [17] "<tr>"                                                                           
      [18] "<td style=\"white-space: nowrap; font-family: monospace; vertical-align: top\">"
      [19] "<code id=\"x\">x</code>"                                                        
      [20] "</td>"                                                                          
      [21] "<td>"                                                                           
      [22] "A parameter"                                                                    
      [23] "</td>"                                                                          
      [24] "</tr>"                                                                          
      [25] "</table>"                                                                       
      [26] ""                                                                               
      [27] "## Value"                                                                       
      [28] ""                                                                               
      [29] "Some value"                                                                     
      [30] ""                                                                               
      [31] "## Examples"                                                                    
      [32] ""                                                                               
      [33] "``` r"                                                                          
      [34] "library(\"testpkg.altdoc\")"                                                    
      [35] ""                                                                               
      [36] ""                                                                               
      [37] "examplesIf_false()"                                                             
      [38] "```"                                                                            

---

    Code
      .readlines("docs/vignettes/test.md")
    Output
      [1] "# test"                  ""                       
      [3] ""                        "``` r"                  
      [5] "library(testpkg.altdoc)" "```"                    
      [7] ""                        "hello there"            

# docute: main files are correct

    Code
      .readlines("docs/README.md")
    Output
       [1] ""                                                                                                  
       [2] ""                                                                                                  
       [3] "<!-- README.md is generated from README.Rmd. Please edit that file -->"                            
       [4] ""                                                                                                  
       [5] "# testpkg.altdoc"                                                                                  
       [6] ""                                                                                                  
       [7] "<!-- badges: start -->"                                                                            
       [8] ""                                                                                                  
       [9] "[![R-universe status"                                                                              
      [10] "badge](https://grantmcdermott.r-universe.dev/badges/plot2)](https://grantmcdermott.r-universe.dev)"
      [11] "<!-- badges: end -->"                                                                              
      [12] ""                                                                                                  
      [13] "The goal of testpkg.altdoc is to …"                                                                
      [14] ""                                                                                                  
      [15] "## Installation"                                                                                   
      [16] ""                                                                                                  
      [17] "You can install the development version of testpkg.altdoc like so:"                                
      [18] ""                                                                                                  
      [19] "``` r"                                                                                             
      [20] "# FILL THIS IN! HOW CAN PEOPLE INSTALL YOUR DEV PACKAGE?"                                          
      [21] "```"                                                                                               
      [22] ""                                                                                                  
      [23] "## Example"                                                                                        
      [24] ""                                                                                                  
      [25] "This is a basic example which shows you how to solve a common problem:"                            
      [26] ""                                                                                                  
      [27] "``` r"                                                                                             
      [28] "library(testpkg.altdoc)"                                                                           
      [29] "summary(cars)"                                                                                     
      [30] "#>      speed           dist       "                                                               
      [31] "#>  Min.   : 4.0   Min.   :  2.00  "                                                               
      [32] "#>  1st Qu.:12.0   1st Qu.: 26.00  "                                                               
      [33] "#>  Median :15.0   Median : 36.00  "                                                               
      [34] "#>  Mean   :15.4   Mean   : 42.98  "                                                               
      [35] "#>  3rd Qu.:19.0   3rd Qu.: 56.00  "                                                               
      [36] "#>  Max.   :25.0   Max.   :120.00"                                                                 
      [37] "```"                                                                                               

---

    Code
      .readlines("docs/docute.html")
    Output
       [1] "<!DOCTYPE html>"                                                                                                                                                                                                                           
       [2] "<html>"                                                                                                                                                                                                                                    
       [3] "  <head>"                                                                                                                                                                                                                                  
       [4] "    <meta charset=\"utf-8\">"                                                                                                                                                                                                              
       [5] "    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1, shrink-to-fit=no\">"                                                                                                                                            
       [6] "    <title>$ALTDOC_PACKAGE_NAME</title>"                                                                                                                                                                                                   
       [7] "    <link rel=\"stylesheet\" href=\"https://unpkg.com/docute@4/dist/docute.css\">"                                                                                                                                                         
       [8] "    <!-- Reduce space between sections and subsections -->"                                                                                                                                                                                
       [9] "     <style>"                                                                                                                                                                                                                              
      [10] "      .page-content h2 {"                                                                                                                                                                                                                  
      [11] "        margin-top: 2em;"                                                                                                                                                                                                                  
      [12] "      }"                                                                                                                                                                                                                                   
      [13] "      .page-content.has-page-title>h2:first-child {"                                                                                                                                                                                       
      [14] "        margin-top: 2em;"                                                                                                                                                                                                                  
      [15] "      }"                                                                                                                                                                                                                                   
      [16] "      .page-content h3 {"                                                                                                                                                                                                                  
      [17] "        margin-top: 2em;"                                                                                                                                                                                                                  
      [18] "      }"                                                                                                                                                                                                                                   
      [19] "      .page-content.has-page-title>h3:first-child {"                                                                                                                                                                                       
      [20] "        margin-top: 2em;"                                                                                                                                                                                                                  
      [21] "      }"                                                                                                                                                                                                                                   
      [22] "    </style>"                                                                                                                                                                                                                              
      [23] "  </head>"                                                                                                                                                                                                                                 
      [24] "  <body>"                                                                                                                                                                                                                                  
      [25] "    <div id=\"docute\"></div>"                                                                                                                                                                                                             
      [26] "    <script src=\"https://unpkg.com/docute@4/dist/docute.js\"></script>"                                                                                                                                                                   
      [27] "    <script>"                                                                                                                                                                                                                              
      [28] "      new Docute({"                                                                                                                                                                                                                        
      [29] "        target: '#docute',"                                                                                                                                                                                                                
      [30] "        title: '$ALTDOC_PACKAGE_NAME',"                                                                                                                                                                                                    
      [31] "        highlight: ['r'],"                                                                                                                                                                                                                 
      [32] "        darkThemeToggler: true,"                                                                                                                                                                                                           
      [33] "        nav: ["                                                                                                                                                                                                                            
      [34] "\t\t\t\t\t{title: 'Home', link: '/' },"                                                                                                                                                                                                    
      [35] "\t\t\t\t\t{title: 'GitHub', link: '$ALTDOC_PACKAGE_URL_GITHUB' },"                                                                                                                                                                         
      [36] "\t\t\t\t],"                                                                                                                                                                                                                                
      [37] "\t\t\t\tsidebar: ["                                                                                                                                                                                                                        
      [38] "\t\t\t\t\t{title: 'Home', link: '/'},"                                                                                                                                                                                                     
      [39] "          {title: 'Articles', children: [$ALTDOC_VIGNETTE_BLOCK]},"                                                                                                                                                                        
      [40] "          {title: 'Reference', children: [$ALTDOC_MAN_BLOCK]},"                                                                                                                                                                            
      [41] "\t\t\t\t\t{title: 'News', link: '$ALTDOC_NEWS'},"                                                                                                                                                                                          
      [42] "\t\t\t\t\t{title: 'Changelog', link: '$ALTDOC_CHANGELOG'},"                                                                                                                                                                                
      [43] "\t\t\t\t\t{title: 'Code of Conduct', link: '$ALTDOC_CODE_OF_CONDUCT'},"                                                                                                                                                                    
      [44] "\t\t\t\t\t{title: 'License', link: '$ALTDOC_LICENSE'},"                                                                                                                                                                                    
      [45] "\t\t\t\t\t{title: 'Licence', link: '$ALTDOC_LICENCE'},"                                                                                                                                                                                    
      [46] "\t\t\t\t\t{title: 'Citation', link: '$ALTDOC_CITATION'}"                                                                                                                                                                                   
      [47] "\t\t\t\t],"                                                                                                                                                                                                                                
      [48] "        footer: \"<a href='$ALTDOC_PACKAGE_URL'> <code> $ALTDOC_PACKAGE_NAME </code> v. $ALTDOC_PACKAGE_VERSION </a> | Documentation made with <a href='https://altdoc.etiennebacher.com/'> <code> altdoc </code> v. $ALTDOC_VERSION</a>\""
      [49] "      })"                                                                                                                                                                                                                                  
      [50] "    </script>"                                                                                                                                                                                                                             
      [51] "  </body>"                                                                                                                                                                                                                                 
      [52] "</html>"                                                                                                                                                                                                                                   

---

    Code
      .readlines("docs/NEWS.md")
    Output
      [1] "# foobar 1.1.0"                                                                                                                     
      [2] ""                                                                                                                                   
      [3] "* thanks [@foo-bar](https://github.com/foo-bar) for their contribution ([#111](https://github.com/etiennebacher/altdoc/issues/111))"
      [4] ""                                                                                                                                   
      [5] "* thanks [@foo2-](https://github.com/foo2-) for their contribution ([#11](https://github.com/etiennebacher/altdoc/issues/11))"      
      [6] ""                                                                                                                                   
      [7] "* thanks [@JohnDoe](https://github.com/JohnDoe), [@JaneDoe](https://github.com/JaneDoe)"                                            
      [8] ""                                                                                                                                   
      [9] "* this should not be linked: foo.bar@email.com"                                                                                     

---

    Code
      .readlines("docs/man/hello_base.md")
    Output
       [1] ""                                                                               
       [2] ""                                                                               
       [3] "# Base function"                                                                
       [4] ""                                                                               
       [5] "## Description"                                                                 
       [6] ""                                                                               
       [7] "Base function"                                                                  
       [8] ""                                                                               
       [9] "## Usage"                                                                       
      [10] ""                                                                               
      [11] "<pre><code class='language-R'>hello_base(x = 2)"                                
      [12] "</code></pre>"                                                                  
      [13] ""                                                                               
      [14] "## Arguments"                                                                   
      [15] ""                                                                               
      [16] "<table>"                                                                        
      [17] "<tr>"                                                                           
      [18] "<td style=\"white-space: nowrap; font-family: monospace; vertical-align: top\">"
      [19] "<code id=\"x\">x</code>"                                                        
      [20] "</td>"                                                                          
      [21] "<td>"                                                                           
      [22] "A parameter"                                                                    
      [23] "</td>"                                                                          
      [24] "</tr>"                                                                          
      [25] "</table>"                                                                       
      [26] ""                                                                               
      [27] "## Details"                                                                     
      [28] ""                                                                               
      [29] "Some code with weird symbols: <code>pl$when(condition)</code> and"              
      [30] "<code>pl$then(output)</code>"                                                   
      [31] ""                                                                               
      [32] "Some equations: ∂*Y*/∂*X* = *a* + *ε*/2"                                        
      [33] ""                                                                               
      [34] "## Value"                                                                       
      [35] ""                                                                               
      [36] "Some value"                                                                     
      [37] ""                                                                               
      [38] "## References"                                                                  
      [39] ""                                                                               
      [40] "Ihaka R, Gentleman R (1996). R: A Language for Data Analysis and"               
      [41] "Graphics. <em>Journal of Computational and Graphical Statistics</em>."          
      [42] "<b>5</b>(3), 299–314."                                                          
      [43] "[doi:10.2307/139080](https://doi.org/10.2307/139080)"                           
      [44] ""                                                                               
      [45] "## See Also"                                                                    
      [46] ""                                                                               
      [47] "<code>print</code>, <code>hello_r6</code>"                                      
      [48] ""                                                                               
      [49] "## Examples"                                                                    
      [50] ""                                                                               
      [51] "``` r"                                                                          
      [52] "library(\"testpkg.altdoc\")"                                                    
      [53] ""                                                                               
      [54] "hello_base()"                                                                   
      [55] "```"                                                                            
      [56] ""                                                                               
      [57] "    [1] \"Hello, world!\""                                                      
      [58] ""                                                                               
      [59] "``` r"                                                                          
      [60] "mtcars$drat <- mtcars$drat + 1"                                                 
      [61] "head(mtcars[[\"drat\"]], 2)"                                                    
      [62] "```"                                                                            
      [63] ""                                                                               
      [64] "    [1] 4.9 4.9"                                                                

---

    Code
      .readlines("docs/man/hello_r6.md")
    Output
        [1] ""                                                                     
        [2] ""                                                                     
        [3] "# Create a \"conductor\" tour"                                        
        [4] ""                                                                     
        [5] "## Description"                                                       
        [6] ""                                                                     
        [7] "blah blah blah"                                                       
        [8] ""                                                                     
        [9] "## Methods"                                                           
       [10] ""                                                                     
       [11] "<h4>"                                                                 
       [12] "Public methods"                                                       
       [13] "</h4>"                                                                
       [14] "<ul>"                                                                 
       [15] "<li>"                                                                 
       [16] ""                                                                     
       [17] "<a href=\"#method-Conductor-new\"><code>hello_r6$new()</code></a>"    
       [18] ""                                                                     
       [19] "</li>"                                                                
       [20] "<li>"                                                                 
       [21] ""                                                                     
       [22] "<a href=\"#method-Conductor-init\"><code>hello_r6$init()</code></a>"  
       [23] ""                                                                     
       [24] "</li>"                                                                
       [25] "<li>"                                                                 
       [26] ""                                                                     
       [27] "<a href=\"#method-Conductor-step\"><code>hello_r6$step()</code></a>"  
       [28] ""                                                                     
       [29] "</li>"                                                                
       [30] "<li>"                                                                 
       [31] ""                                                                     
       [32] "<a href=\"#method-Conductor-clone\"><code>hello_r6$clone()</code></a>"
       [33] ""                                                                     
       [34] "</li>"                                                                
       [35] "</ul>"                                                                
       [36] "<hr>"                                                                 
       [37] ""                                                                     
       [38] "<a id=\"method-Conductor-new\"></a>"                                  
       [39] ""                                                                     
       [40] "<h4>"                                                                 
       [41] "Method <code>new()</code>"                                            
       [42] "</h4>"                                                                
       [43] "<h5>"                                                                 
       [44] "Usage"                                                                
       [45] "</h5>"                                                                
       [46] ""                                                                     
       [47] "<pre>hello_r6\\$new()</pre>"                                          
       [48] ""                                                                     
       [49] "<h5>"                                                                 
       [50] "Details"                                                              
       [51] "</h5>"                                                                
       [52] ""                                                                     
       [53] "Initialise <code>Conductor</code>."                                   
       [54] ""                                                                     
       [55] "<hr>"                                                                 
       [56] ""                                                                     
       [57] "<a id=\"method-Conductor-init\"></a>"                                 
       [58] ""                                                                     
       [59] "<h4>"                                                                 
       [60] "Method <code>init()</code>"                                           
       [61] "</h4>"                                                                
       [62] "<h5>"                                                                 
       [63] "Usage"                                                                
       [64] "</h5>"                                                                
       [65] ""                                                                     
       [66] "<pre>hello_r6\\$init(session = NULL)</pre>"                           
       [67] ""                                                                     
       [68] "<h5>"                                                                 
       [69] "Arguments"                                                            
       [70] "</h5>"                                                                
       [71] ""                                                                     
       [72] "<dl>"                                                                 
       [73] "<dt>"                                                                 
       [74] "<code>session</code>"                                                 
       [75] "</dt>"                                                                
       [76] "<dd>"                                                                 
       [77] "A valid Shiny session. If <code>NULL</code> (default), the function"  
       [78] "attempts to get the session with"                                     
       [79] "<code>shiny::getDefaultReactiveDomain()</code>."                      
       [80] "</dd>"                                                                
       [81] "</dl>"                                                                
       [82] ""                                                                     
       [83] "<h5>"                                                                 
       [84] "Details"                                                              
       [85] "</h5>"                                                                
       [86] ""                                                                     
       [87] "Initialise <code>Conductor</code>."                                   
       [88] ""                                                                     
       [89] "<hr>"                                                                 
       [90] ""                                                                     
       [91] "<a id=\"method-Conductor-step\"></a>"                                 
       [92] ""                                                                     
       [93] "<h4>"                                                                 
       [94] "Method <code>step()</code>"                                           
       [95] "</h4>"                                                                
       [96] "<h5>"                                                                 
       [97] "Usage"                                                                
       [98] "</h5>"                                                                
       [99] ""                                                                     
      [100] "<pre>hello_r6\\$step(title = NULL)</pre>"                             
      [101] ""                                                                     
      [102] "<h5>"                                                                 
      [103] "Arguments"                                                            
      [104] "</h5>"                                                                
      [105] ""                                                                     
      [106] "<dl>"                                                                 
      [107] "<dt>"                                                                 
      [108] "<code>title</code>"                                                   
      [109] "</dt>"                                                                
      [110] "<dd>"                                                                 
      [111] "Title of the popover."                                                
      [112] "</dd>"                                                                
      [113] "</dl>"                                                                
      [114] ""                                                                     
      [115] "<h5>"                                                                 
      [116] "Details"                                                              
      [117] "</h5>"                                                                
      [118] ""                                                                     
      [119] "Add a step in a <code>Conductor</code> tour."                         
      [120] ""                                                                     
      [121] "<hr>"                                                                 
      [122] ""                                                                     
      [123] "<a id=\"method-Conductor-clone\"></a>"                                
      [124] ""                                                                     
      [125] "<h4>"                                                                 
      [126] "Method <code>clone()</code>"                                          
      [127] "</h4>"                                                                
      [128] ""                                                                     
      [129] "The objects of this class are cloneable with this method."            
      [130] ""                                                                     
      [131] "<h5>"                                                                 
      [132] "Usage"                                                                
      [133] "</h5>"                                                                
      [134] ""                                                                     
      [135] "<pre>hello_r6\\$clone(deep = FALSE)</pre>"                            
      [136] ""                                                                     
      [137] "<h5>"                                                                 
      [138] "Arguments"                                                            
      [139] "</h5>"                                                                
      [140] ""                                                                     
      [141] "<dl>"                                                                 
      [142] "<dt>"                                                                 
      [143] "<code>deep</code>"                                                    
      [144] "</dt>"                                                                
      [145] "<dd>"                                                                 
      [146] "Whether to make a deep clone."                                        
      [147] "</dd>"                                                                
      [148] "</dl>"                                                                

---

    Code
      .readlines("docs/man/examplesIf_true.md")
    Output
       [1] ""                                                                               
       [2] ""                                                                               
       [3] "# Examples If TRUE"                                                             
       [4] ""                                                                               
       [5] "## Description"                                                                 
       [6] ""                                                                               
       [7] "Examples If TRUE"                                                               
       [8] ""                                                                               
       [9] "## Usage"                                                                       
      [10] ""                                                                               
      [11] "<pre><code class='language-R'>examplesIf_true()"                                
      [12] "</code></pre>"                                                                  
      [13] ""                                                                               
      [14] "## Arguments"                                                                   
      [15] ""                                                                               
      [16] "<table>"                                                                        
      [17] "<tr>"                                                                           
      [18] "<td style=\"white-space: nowrap; font-family: monospace; vertical-align: top\">"
      [19] "<code id=\"x\">x</code>"                                                        
      [20] "</td>"                                                                          
      [21] "<td>"                                                                           
      [22] "A parameter"                                                                    
      [23] "</td>"                                                                          
      [24] "</tr>"                                                                          
      [25] "</table>"                                                                       
      [26] ""                                                                               
      [27] "## Value"                                                                       
      [28] ""                                                                               
      [29] "Some value"                                                                     
      [30] ""                                                                               
      [31] "## Examples"                                                                    
      [32] ""                                                                               
      [33] "``` r"                                                                          
      [34] "library(\"testpkg.altdoc\")"                                                    
      [35] ""                                                                               
      [36] ""                                                                               
      [37] "examplesIf_true()"                                                              
      [38] "```"                                                                            
      [39] ""                                                                               
      [40] "    [1] \"Hello, world!\""                                                      

---

    Code
      .readlines("docs/man/examplesIf_false.md")
    Output
       [1] ""                                                                               
       [2] ""                                                                               
       [3] "# Examples If FALSE"                                                            
       [4] ""                                                                               
       [5] "## Description"                                                                 
       [6] ""                                                                               
       [7] "Examples If FALSE"                                                              
       [8] ""                                                                               
       [9] "## Usage"                                                                       
      [10] ""                                                                               
      [11] "<pre><code class='language-R'>examplesIf_false()"                               
      [12] "</code></pre>"                                                                  
      [13] ""                                                                               
      [14] "## Arguments"                                                                   
      [15] ""                                                                               
      [16] "<table>"                                                                        
      [17] "<tr>"                                                                           
      [18] "<td style=\"white-space: nowrap; font-family: monospace; vertical-align: top\">"
      [19] "<code id=\"x\">x</code>"                                                        
      [20] "</td>"                                                                          
      [21] "<td>"                                                                           
      [22] "A parameter"                                                                    
      [23] "</td>"                                                                          
      [24] "</tr>"                                                                          
      [25] "</table>"                                                                       
      [26] ""                                                                               
      [27] "## Value"                                                                       
      [28] ""                                                                               
      [29] "Some value"                                                                     
      [30] ""                                                                               
      [31] "## Examples"                                                                    
      [32] ""                                                                               
      [33] "``` r"                                                                          
      [34] "library(\"testpkg.altdoc\")"                                                    
      [35] ""                                                                               
      [36] ""                                                                               
      [37] "examplesIf_false()"                                                             
      [38] "```"                                                                            

---

    Code
      .readlines("docs/vignettes/test.md")
    Output
      [1] "# test"                  ""                       
      [3] ""                        "``` r"                  
      [5] "library(testpkg.altdoc)" "```"                    
      [7] ""                        "hello there"            

# first section

hello there, this document doesn't have a preamble

# path

here's a path to a badge: [![R-universe status
badge](https://grantmcdermott.r-universe.dev/badges/plot2)](https://grantmcdermott.r-universe.dev)

---
title: "Analysing Longitudinal or Panel Data"
output: 
  rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Analysing Longitudinal or Panel Data}
  \usepackage[utf8]{inputenc}
  %\VignetteEngine{knitr::rmarkdown}
---

Hello this is a vignette.

Here's some code:

```{r}
print(mtcars)
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/examplesIf_true.R
\name{examplesIf_true}
\alias{examplesIf_true}
\title{Examples If TRUE}
\usage{
examplesIf_true()
}
\arguments{
\item{x}{A parameter}
}
\value{
Some value
}
\description{
Examples If TRUE
}
\examples{
\dontshow{if (2 + 2 == 4) (if (getRversion() >= "3.4") withAutoprint else force)(\{ # examplesIf}
examplesIf_true()
\dontshow{\}) # examplesIf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hello_base.R
\name{hello_base}
\alias{hello_base}
\title{Base function}
\usage{
hello_base(x = 2)
}
\arguments{
\item{x}{A parameter}
}
\value{
Some value
}
\description{
Base function
}
\details{
Some code with weird symbols: \code{pl$when(condition)} and \code{pl$then(output)}

Some equations: \eqn{\partial Y / \partial X = a + \varepsilon/2}
}
\examples{
hello_base()

mtcars$drat <- mtcars$drat + 1
head(mtcars[["drat"]], 2)
}
\references{
Ihaka R, Gentleman R (1996).
R: A Language for Data Analysis and Graphics.
\emph{Journal of Computational and Graphical Statistics}. \bold{5}(3), 299--314.
\doi{10.2307/139080}
}
\seealso{
\code{\link[base]{print}}, \code{\link{hello_r6}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hello_r6.R
\name{hello_r6}
\alias{hello_r6}
\title{Create a "conductor" tour}
\description{
blah blah blah
}
\section{Methods}{
\subsection{Public methods}{
\itemize{
\item \href{#method-Conductor-new}{\code{hello_r6$new()}}
\item \href{#method-Conductor-init}{\code{hello_r6$init()}}
\item \href{#method-Conductor-step}{\code{hello_r6$step()}}
\item \href{#method-Conductor-clone}{\code{hello_r6$clone()}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Conductor-new"></a>}}
\if{latex}{\out{\hypertarget{method-Conductor-new}{}}}
\subsection{Method \code{new()}}{
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{hello_r6$new()}\if{html}{\out{</div>}}
}

\subsection{Details}{
Initialise \code{Conductor}.
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Conductor-init"></a>}}
\if{latex}{\out{\hypertarget{method-Conductor-init}{}}}
\subsection{Method \code{init()}}{
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{hello_r6$init(session = NULL)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{session}}{A valid Shiny session. If \code{NULL} (default), the function
attempts to get the session with \code{shiny::getDefaultReactiveDomain()}.}
}
\if{html}{\out{</div>}}
}
\subsection{Details}{
Initialise \code{Conductor}.
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Conductor-step"></a>}}
\if{latex}{\out{\hypertarget{method-Conductor-step}{}}}
\subsection{Method \code{step()}}{
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{hello_r6$step(title = NULL)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{title}}{Title of the popover.}
}
\if{html}{\out{</div>}}
}
\subsection{Details}{
Add a step in a \code{Conductor} tour.
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-Conductor-clone"></a>}}
\if{latex}{\out{\hypertarget{method-Conductor-clone}{}}}
\subsection{Method \code{clone()}}{
The objects of this class are cloneable with this method.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{hello_r6$clone(deep = FALSE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{deep}}{Whether to make a deep clone.}
}
\if{html}{\out{</div>}}
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/funs.R
\name{foobar}
\alias{foobar}
\title{Some function}
\keyword{internal}
\usage{
  foo(x)
}
\arguments{
  \item{x}{hello there}
}
\description{
  foo
}
\examples{
  print(a)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/funs.R
\name{between}
\alias{between}
\title{Do values in a numeric vector fall in specified range?}
\usage{
  between(x, left, right)
}
\arguments{
  \item{x}{A numeric vector of values}

  \item{left, right}{Boundary values (must be scalars).}
}
\description{
  This is a shortcut for \code{x >= left & x <= right}, implemented
  efficiently in C++ for local values, and translated to the
  appropriate SQL for remote tables.
}
